﻿using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 항목
    /// </summary>
    public class Item
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 대분류 - CATEGORY1

        /// <summary>
        /// 대분류
        /// </summary>
        public string CATEGORY1 { get; set; }

        #endregion
        #region 중분류 - CATEGORY2

        /// <summary>
        /// 중분류
        /// </summary>
        public string CATEGORY2 { get; set; }

        #endregion
        #region 연월 - YYYYMM

        /// <summary>
        /// 연월
        /// </summary>
        public string YYYYMM { get; set; }

        #endregion
        #region 금액 - AMOUNT

        /// <summary>
        /// 금액
        /// </summary>
        public decimal AMOUNT { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 항목 리스트 구하기 - GetItemList()

        /// <summary>
        /// 항목 리스트 구하기
        /// </summary>
        /// <returns>항목 리스트</returns>
        public static List<Item> GetItemList()
        {
            List<Item> itemList = new List<Item>();

            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "세금", YYYYMM = "201901", AMOUNT = 165000  });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201901", AMOUNT = 53000   });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "교통", YYYYMM = "201901", AMOUNT = 2400    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201901", AMOUNT = 224000  });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "교통", YYYYMM = "201901", AMOUNT = 3800    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201901", AMOUNT = 38000   });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "생활", YYYYMM = "201901", AMOUNT = 5000    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "생활", YYYYMM = "201901", AMOUNT = 2500    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "교통", YYYYMM = "201901", AMOUNT = 3800    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201901", AMOUNT = 42000   });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "생활", YYYYMM = "201901", AMOUNT = 15000   });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "세금", YYYYMM = "201902", AMOUNT = 165000  });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201902", AMOUNT = 153000  });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "교통", YYYYMM = "201902", AMOUNT = 4200    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201902", AMOUNT = 24000   });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "교통", YYYYMM = "201902", AMOUNT = 8300    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201902", AMOUNT = 83000   });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "생활", YYYYMM = "201902", AMOUNT = 1500    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "교통", YYYYMM = "201902", AMOUNT = 3800    });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "식비", YYYYMM = "201902", AMOUNT = 24000   });
            itemList.Add(new Item { CATEGORY1 = "비용", CATEGORY2 = "생활", YYYYMM = "201902", AMOUNT = 3500    });

            return itemList;
        }

        #endregion
    }
}